/*--------------------------------------|
|File:		 lcd.h						|
|Date:   	 August 2011				|
|Author:	 J. Moertl					|
|Description:Headerfile for lcd function|
|--------------------------------------*/
#ifndef _LCD_H
#define _LCD_H

//----------------- Definitions -----------
#define DELETE 0
#define ADD	1
#define INVERS 2


//-------------- Global varibales ----------
//extern unsigned char lcd_buffer[XPIXEL][YPIXEL/8];
//extern uint8_t lcd_buffer[170][27];  //nur 4 pixel pro page

//--------------- Macrofuncitons ----------
#define lcd_send_command(data) lcd_send(data, 0)
#define lcd_send_data(data) lcd_send(data, 1)
#define lcd_clear_all() lcd_clear(0,0,XPIXEL-1,YPIXEL-1)
#define lcd_fill_all() lcd_fill(0,0,XPIXEL-1,YPIXEL-1)

//----------------- Functions ------------
void lcd_init(void);
void lcd_send(uint8_t data, uint8_t cd);
//void lcd_clear(uint8_t xs, uint8_t ys, uint8_t xe, uint8_t ye);
void lcd_fill(uint8_t xs, uint8_t ys, uint8_t xe, uint8_t ye,uint8_t color);
void lcd_pixel(uint8_t xs, uint8_t ys, uint8_t color);
void lcd_line(uint8_t xs, uint8_t ys, uint8_t xe, uint8_t ye, uint8_t color);
void lcd_rect(uint8_t xs, uint8_t ys, uint8_t xe, uint8_t ye, uint8_t color);
void lcd_byte(uint8_t x, uint8_t y, uint8_t data, uint8_t color,uint8_t linkmode);
void lcd_char(uint8_t x, uint8_t y, uint8_t data, uint8_t *font, uint8_t linkmode);
void lcd_string(uint8_t x, uint8_t y, char *data, uint8_t *font, uint8_t linkmode );
uint8_t high_page(uint8_t byte, uint8_t color);
uint8_t low_page(uint8_t byte, uint8_t color);
void lcd_clrscr(uint8_t fill);

#endif
//----------------- EOF lcd.h ------------
