/*--------------------------------------|
|File:		 main.c						|
|Date:   	 August 2011				|
|Author:	 J. Moertl					|
|Description:Main file, controlling all |
|			 important functions, 		|
|			 including main loop.       |
|										|
|The code is written to controll 		|
|EA DOGS102-6 from ELECTRONIC ASSEMBLY	|
|	http://www.lcd-module.com			|
|--------------------------------------*/



/*Additional information:
The code is tested on Atmel ATMega168
The ports have the folling configuration:

ATMega 168 | EA DOGS102-6
--------------------------
PB0		   | RST (PIN 27)
PB1 	   | CD  (PIN 26)
PB2		   | CS0 (PIN 28)
PB3 MISO   | SDA (PIN 24)
PB5 SCK    | SCK (PIN 25)

The testscreen should look like you can see on the foto:
sample_screen.JPG

The makefile can be used to compile with WinAVR and programmers' notepad.
http://www.pnotepad.org
The flasher I used, was the Burn'o'Mat.
http://burn-o-mat.net
*/


#include "main.h"  //definitions and other includes

char text[22];


	
int main (void)
{
	
	RS232_Init();
	
	DDRB |= (1<<PINB4);
	
	_delay_ms(500);
	
	printf("*Init LCD\n");
		
	spi_init(); //Init spi
	
	sei(); //global interrupt enabled

	_delay_ms(50);  //let display run up
	
	lcd_init(); //init EA DOGXL
	
	lcd_clrscr(0);
	
	
	lcd_char(44,40,'A', ptr_font_8x16, ADD);

	_delay_ms(5000);  
	
	lcd_clrscr(0);
	_delay_ms(2000);  
	
	//lcd_byte(154,32,255,3,ADD); //der ist das Problem
	// weiss mitllerweile, dass der Zugriff auf lcd_buffer das Problem ist

	

	

	
	lcd_char(0,0,sym_temp,ptr_symbols, ADD);
	text[0]='+';
	text[1]='2';
	text[2]='3';
	text[3]='.';
	text[4]='5';
	text[5]=248;
	text[6]='C';
	text[7]='\0';
	lcd_string(25,7,text, ptr_font_8x16, ADD);
	//lcd_string(25,7,text, ptr_font_6x8, ADD);
	
	
	lcd_char(0,30,sym_wind,ptr_symbols, ADD);
	text[0]=' ';
	text[1]='6';
	text[2]='.';
	text[3]='3';
	text[4]='\0';
	uint8_t t_s_x=25,t_s_y=37;
	//lcd_string(t_s_x,t_s_y,text,ptr_font_6x8, ADD);
	lcd_string(t_s_x,t_s_y,text,ptr_font_8x16, ADD);
	lcd_char(t_s_x+33,t_s_y,'m',ptr_font_6x8, ADD);
	lcd_char(t_s_x+33,t_s_y+8,'s',ptr_font_6x8, ADD);
	lcd_line(t_s_x+32,t_s_y+8,t_s_x+32+7,t_s_y+8,3);
	
	lcd_char(0,60,sym_sonne,ptr_symbols, ADD);
	text[0]='5';
	text[1]='2';
	text[2]='k';
	text[3]='l';
	text[4]='x';
	text[5]='\0';
	lcd_string(t_s_x,67,text, ptr_font_8x16, ADD);
	//lcd_string(t_s_x,67,text, ptr_font_6x8, ADD);
	
	lcd_char(82,0,sym_gas,ptr_symbols, ADD);
	lcd_char(82,30,sym_elektro,ptr_symbols, ADD);
	lcd_char(82,60,sym_wasser,ptr_symbols, ADD);
	
	lcd_line(81,0,81,91,3);

	
	lcd_line(0,91,150,91,3);
	lcd_line(41,91,41,103,3);
	lcd_line(81,91,81,103,3);
	lcd_line(121,91,121,103,3);
	

	//---------Main loop--------------//
	while (1)
	{
		PORTB &=~(1<<PINB4);
		
		lcd_fill(0,92,40,103,0);
		lcd_string(0,95,text, ptr_font_6x8,ADD);
		_delay_ms(1000);
		PORTB |= (1<<PINB4);
		
		lcd_fill(0,92,40,103,1);
		lcd_string(0,95,text, ptr_font_6x8,ADD);
		_delay_ms(1000);
		
		
		
	}
	//---------EOF main loop--------------//

	//cli(); //global interrupt off
	return 0;
}


//----------------- EOF main.c ------------
