/*--------------------------------------|
|File:		 spi.c						|
|Date:   	 August 2011				|
|Author:	 J. Moertl					|
|Description:Source data to init and	|
|			 use spi					|
|--------------------------------------*/

#include "main.h"

/*--------------------------------------
Function:	spi_init()
Input:		---
Output:		---
Description:Initializes SPI
--------------------------------------*/
void spi_init(void)
{
        volatile uint8_t IOReg;
	
	
//Hardware SPI
	/*
		// set PB3(MOSI), PB5(SCK), PB2(SS), PB1(CD) as output
        //DDRB    |= (1<<PB3)|(1<<PB5)|(1<<DCS)|(1<<DCD);  //Mega16
	DDRB    |= (1<<PINB5)|(1<<PINB7)|(1<<DCS)|(1<<DCD);  //Mega128P
	*/
	
	// Für Soft-SPI
	DDRB    |= (1<<SPI_CLK)|(1<<SPI_DO)|(1<<DCS)|(1<<DCD);  //PB0 als SCK PB1 als MOSI

		// enable SPI in Master Mode with SCK = CK/4, CPHA = 1
        SPCR    = (1<<SPE)|(1<<MSTR)|(1<<CPHA)|(1<<CPOL);
	SPSR = (0<<SPI2X);
	/*
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<SPR1); //Enable SPI, SPI in Master Mode	
	SPSR = (0<<SPI2X);
	*/

        IOReg   = SPSR;         //clear SPIF bit in SPSR
        IOReg   = SPDR;			//clear receive buffer
		PORTB |= (1<<DCD);		//SS high
		PORTB |= (1<<DCS);		//CD high
}




/*--------------------------------------
Function:	spi_byte()
Input:		data
Output:		---
Description:Sends one byte of data and
			wait until transfer is
			completed
--------------------------------------*/
uint8_t spi_byte (uint8_t data)
{
	uint8_t a;
	/*
	printf("in spi %d\n",data);
	SPDR = data; //send data
	while (!(SPSR & (1<<SPIF))){};    // wait until byte is sent and received
	printf("out spi: %d\n",SPSR);
	return SPDR; //return received data (not used with EA DOGS102-6,
				 //but you have to read out, because ATMega needs it
	*/
	// Soft SPI  
	
	//printf("D %d",data);
	
	for (a=8; a>0; a--) //das Byte wird Bitweise nacheinander Gesendet MSB First
	{
		if (bit_is_set(data,(a-1))>0)	//Ist Bit a in Byte gesetzt
		{
			//MMC_Write |= (1<<SPI_DO); //Set Output High
			PORTB |= (1<<SPI_DO); //Set Output High
			//printf("1");
			
		}
		else
		{
			//MMC_Write &= ~(1<<SPI_DO); //Set Output Low
			PORTB &= ~(1<<SPI_DO); //Set Output Low
			//printf("0");
		}	
		//MMC_Write &= ~(1<<SPI_Clock);	//erzeugt ein Clock Impuls (LOW)
		PORTB &= ~(1<<SPI_CLK);	//erzeugt ein Clock Impuls (LOW)
		
		
		
		//MMC_Write |= (1<<SPI_Clock); //setzt Clock Impuls wieder auf (High)
		PORTB |= (1<<SPI_CLK);
	}
	//MMC_Write |= (1<<SPI_DO);	//setzt Output wieder auf High	
	PORTB |= (1<<SPI_DO);
	//printf(" ");
	

	
}


//----------------- EOF spi.c ------------
